
//
// A skeleton for how to implement events on components.
//

import java.util.Vector;

// A Beans listener interface

interface ClickListener /* extends java.util.EventListener */ {
    void click( ClickEvent event );
}

// A Beans event data class

class ClickEvent /* extends java.util.EventObject */ {
    public ClickEvent( Object source ) {
	//super( source );

	_source = source;
    }

    public Object getSource() {
	return _source;
    }

    private Object _source;
}

// A Beans event source

public class MyComponent {
    private Vector _clickListeners = new Vector();

    public synchronized void addClickListener( ClickListener listener ) {
	_clickListeners.addElement( listener );
    }

    public synchronized void removeClickListener( ClickListener listener ) {
	_clickListeners.removeElement( listener );
    }

    protected void handleClick( ClickEvent event ) {
	Vector l;

	synchronized( this ) {
	    l = (Vector) _clickListeners.clone();
	}

	for( int i = 0; i < l.size(); ++i ){
	    ((ClickListener) l.elementAt(i)).click( event );
	}
    }
}
