//
// A simple extension of the AWT Button class to support the new
// event model.
//

import java.util.Vector;

public class PushButton extends java.awt.Button {
    public PushButton( String title ) {
	super( title );
    }

    private Vector _clickListeners = new Vector();

    public synchronized void addClickListener( ClickListener listener ) {
	_clickListeners.addElement( listener );
    }

    public synchronized void removeClickListener( ClickListener listener ) {
	_clickListeners.removeElement( listener );
    }

    protected void handleClick( ClickEvent event ) {
	Vector l;

	synchronized( this ) {
	    l = (Vector) _clickListeners.clone();
	}

	for( int i = 0; i < l.size(); ++i ){
	    ((ClickListener) l.elementAt(i)).click( event );
	}
    }

    public boolean handleEvent( java.awt.Event event ) {
	if( event.id == java.awt.Event.ACTION_EVENT ){
	    handleClick( new ClickEvent( this ) );
	    return true;
	}

	return false;
    }
}
