// NetLic.cpp : implementation file
//

#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <process.h>
#include "Validate.h"
#include "dplay.h"
#include "NetLic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


GUID VALIDATE_LICENSE = { /* ad770780-c60c-11cf-af52-0000b430cfd2 */
    0xad770780,
    0xc60c,
    0x11cf,
    {0xaf, 0x52, 0x00, 0x00, 0xb4, 0x30, 0xcf, 0xd2}
  };

/////////////////////////////////////////////////////////////////////////////
// CNetLicense dialog


CNetLicense::CNetLicense(CWnd* pParent /*=NULL*/)
	: CDialog(CNetLicense::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNetLicense)
	m_UserCount = _T("");
	//}}AFX_DATA_INIT
}


void CNetLicense::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNetLicense)
	DDX_Control(pDX, IDC_USERLIST, m_UserList);
	DDX_Control(pDX, IDC_NETLIST, m_LB_Nets);
	DDX_Text(pDX, IDC_USERCOUNT, m_UserCount);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNetLicense, CDialog)
	//{{AFX_MSG_MAP(CNetLicense)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetLicense message handlers
void CNetLicense::SetID(WORD wSerialNumber, WORD wUserCount, HWND hParent)
{
	// sets the class's startup information, failing to do this will creatr
	// 'bad' problems
	m_wSerialNumber = wSerialNumber;
	m_wUserCount = wUserCount;
	m_hParent = hParent;
}

int CNetLicense::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	m_bEnumNets = TRUE;
	m_lpGuidTCP = NULL;
	m_lpGuidIPX = NULL;
	m_bFoundSession = FALSE;
	m_lSessions = 0;
	m_bDontCheck = FALSE;

	m_lPlayers = 0;
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	#ifdef _DEBUG
	afxDump << "Generating Debug Window!\n";	
	#endif

	return 0;
}

BOOL CALLBACK CNetLicense::EnumNetSup(LPGUID lpGuid, LPSTR lpDesc, DWORD dwMajorVersion, 
									DWORD dwMinorVersion, LPVOID lpv)
{			 

	CNetLicense *MyNet = (CNetLicense *)lpv;
	LONG iIndex = MyNet->m_LB_Nets.AddString(lpDesc);
	if(iIndex == LB_ERR)
	{
		#ifdef _DEBUG
		afxDump << "Listbox error in CNetLicense\n";
		#endif
		
		return FALSE;
	}

	MyNet->m_LB_Nets.SetItemData(iIndex,(LPARAM) lpGuid);

	#ifdef _DEBUG
	afxDump << lpDesc << " " << lpGuid << "\n";
	#endif
		 
	if(strstr(lpDesc,"TCP") != NULL)
		 MyNet->m_lpGuidTCP = lpGuid;
	else if (strstr(lpDesc, "IPX") != NULL)
		 MyNet->m_lpGuidIPX = lpGuid;


	return TRUE;
}

BOOL CNetLicense::EnumNetProviders(void)
{
	#ifdef _DEBUG
	afxDump << "Network Providers:\n";
	#endif

	if(DirectPlayEnumerate(EnumNetSup,(void *) this) != DP_OK)
	{
		#ifdef _DEBUG
			afxDump << "Enumeration of Net Providers: Failed\n";
		#else
			MessageBox("Network Enumeration Failed","Fatel Error",
				MB_OK | MB_ICONSTOP);
		#endif
	return FALSE;
	}
	
	#ifdef _DEBUG
	afxDump << "Enumeration of Net Providers: Successful\n";
	#endif	
		
	return TRUE;
}

BOOL CNetLicense::EnumTCPSessions(void)
{
	
	if(DirectPlayCreate(m_lpGuidTCP, &m_lpIDC, NULL) != DP_OK)
	{
	#ifdef _DEBUG
		afxDump << "Initailization of TCP Network: Failed\n";
	#endif
	
		return FALSE;
	}

	#ifdef _DEBUG
	afxDump << "Initailization of TCP Network: Successful\n";
	afxDump << "TCP Session List:\n";
	#endif

	memset(&m_dpDesc, 0x00, sizeof(DPSESSIONDESC));
    m_dpDesc.dwSize = sizeof(m_dpDesc);
	m_dpDesc.guidSession = VALIDATE_LICENSE;
	m_dpDesc.dwSession = m_wSerialNumber;
	
	switch((HRESULT)m_lpIDC->EnumSessions(&m_dpDesc,1500,EnumNetSesssions,this,0))
	{
	case DPERR_NOSESSIONS:
		#ifdef _DEBUG
		afxDump << "No Sessions\n";
		#endif
		
		m_dpDesc.dwFlags = DPOPEN_CREATESESSION;
	
		break;

	case DP_OK:
		#ifdef _DEBUG
		afxDump << "It's Good!\n";
		#endif

		if(m_bFoundSession == TRUE)
		{
			m_dpDesc.dwSession = m_lSessionID;
			m_dpDesc.dwFlags = DPOPEN_OPENSESSION;
		}
		else
			m_dpDesc.dwFlags = DPOPEN_CREATESESSION;
		
		break;

	default:
		#ifdef _DEBUG
		afxDump << " Got something wierd back!!\n";
		#endif
		return FALSE;
	}


	#ifdef _DEBUG
	afxDump << "Session Enumeration Successful\n";
	#endif
	
	m_dpDesc.dwMaxPlayers = 255;
	itoa((int)m_wSerialNumber,m_dpDesc.szSessionName,10);
	
	if(m_lpIDC->Open(&m_dpDesc) != DP_OK)
	{
		#ifdef _DEBUG
		afxDump << "Session has failed\n";
		#endif
	
		return FALSE;
	}

	#ifdef _DEBUG
	afxDump << "Session is working\n";
	#endif
	
	return TRUE;					   
}


BOOL CALLBACK CNetLicense::EnumNetSesssions(LPDPSESSIONDESC lpDPSGameDesc,
    		LPVOID lpContext, LPDWORD lpdwTimeOut, DWORD dwFlags)
{			 
	if(dwFlags == DPESC_TIMEDOUT)
	{
		#ifdef _DEBUG
		afxDump << "Timed Out\n";
		#endif
	
		return FALSE;
	}

	CNetLicense *MyNet = (CNetLicense *)lpContext;
	MyNet->m_lSessions++;

	if(atoi((char *)lpDPSGameDesc->szSessionName) == MyNet->m_wSerialNumber)
	{
		 MyNet->m_bFoundSession = TRUE;
		 MyNet->m_lSessionID = lpDPSGameDesc->dwSession;
	}

	#ifdef _DEBUG
	afxDump << lpDPSGameDesc->dwSession << " " << lpDPSGameDesc->szSessionName;
	afxDump << " " <<  MyNet->m_bFoundSession << "\n";	
	#endif

	return TRUE;
}

BOOL CNetLicense::CreateUser(void)
{
		
	HRESULT hr;
    char    chPlayerName[255];
	char	chComputerName[255];
    static  int iNumber = 1;
    
	DWORD iBufferSize = 252;

	srand( (unsigned)time( NULL ) );


	if(!GetUserName(chPlayerName,(LPDWORD) &iBufferSize) )
	{
		#ifdef _DEBUG
		afxDump << "No user name\n";
		#endif

		return FALSE;
	}

	#ifdef _DEBUG
	afxDump << "User name: " << chPlayerName << "\n";
	#endif

	if(!GetUserName(chComputerName,(LPDWORD) &iBufferSize))
		strcpy(chComputerName,chPlayerName);
	

	#ifdef _DEBUG
	afxDump << "Computer name: " << chComputerName << "\n";
	#endif

	if((hr = m_lpIDC->CreatePlayer(&m_dwPlayer, chPlayerName, 
		chComputerName, &hPlayerEvent)	!= DP_OK))
	{
	int wCount = 32;
	while(wCount)
		{
			// Because of a strange problem in the GDK,
			// If  user exits and then tries to re-enter,
			// he may get the same user id as befor. This
			// causes the user to fail in the creation. This code
			// randomly generates a user ID so that the user 
			// will be able to enter.

			m_dwPlayer = rand();
			if(m_lpIDC->CreatePlayer(&m_dwPlayer, chPlayerName, 
				chComputerName, &hPlayerEvent) == DP_OK)
			{
				wCount = 0;
				#ifdef _DEBUG
				afxDump << "New user generated successfully\n";
				#endif
				return TRUE;
			}
			wCount--;
		}
	
	#ifdef _DEBUG
	afxDump << "Failed to create user\n";
	#endif
	
	return FALSE;
	}
        
		
	#ifdef _DEBUG
	afxDump << "New user generated successfully\n";
	#endif
	
	return TRUE;
}



BOOL CNetLicense::EnumNetUsers( DPID pidID, LPSTR lpFriendlyName,
		LPSTR lpFormalName, DWORD dwFlags, LPVOID lpContext)
{

	CNetLicense *MyNet = (CNetLicense *)lpContext;
	MyNet->m_lPlayers++;
	
	#ifdef _DEBUG
	afxDump << pidID << " " << lpFriendlyName << "\n";
	#endif

	MyNet->m_UserList.AddString (lpFriendlyName);
	return TRUE;
}



BOOL CNetLicense::EnumUsers(void)
{
	HRESULT hr;
	
	#ifdef _DEBUG
	afxDump << "Users:\n";
	#endif
	
	if((hr = m_lpIDC->EnumPlayers(m_wSerialNumber,EnumNetUsers, 
		(LPVOID) this,DPENUMPLAYERS_GROUP)) != DP_OK)
	{
		#ifdef _DEBUG
		switch(hr)
		{
		case DPERR_GENERIC:
			afxDump << "DPERR_GENERIC\n";
			break;
		case DPERR_EXCEPTION:
			afxDump << "DPERR_EXCEPTION\n";
			break;
		case DPERR_INVALIDOBJECT:
			afxDump << "DPERR_INVALIDOBJECT\n";
			break;
		case DPERR_UNSUPPORTED:
			afxDump << "DPERR_UNSUPPORTED\n";
			break;
		default:
			afxDump << "Unknown error\n";
			break;
		}
		#endif
		
		return FALSE;
	}

	#ifdef _DEBUG
	afxDump << "End of User List\n";
	#endif
	
	if(!m_bDontCheck)
	if((m_lPlayers + 1) > m_wUserCount)
	{
		::SendMessage(m_hParent, WM_INVALIDLICENSE,0,0);
		return FALSE;
	}
	return TRUE;
}

void CNetLicense::OnPaint() 
{

	CPaintDC dc(this); 
	
	/* -------------
	This code creates the entire user validation process.
	It first creates that it hasn't already tested the net.
	Next it enumerates the network providers (TCP or IPX, modem is not used).
	It then enumerates all the net sessions looking for the serial number
	passed to this class. If it is not found, then the class generates a new
	serial number, otherwise it opens the existing session and confirms that
	the curent user count is valid. If it is, a new user is created. Finally 
	a message process handler is kicked off to handle network messages.
	-----------------*/

	if(m_bEnumNets)
	{
		m_lSessions = FALSE;
		if(EnumNetProviders())
		{
			if(EnumTCPSessions())
			{
				if(EnumUsers())
					if(CreateUser())
						_beginthread(MessageSpin,0,this);
			}
		}
		m_bEnumNets = FALSE;
	}

}

void CNetLicense::OnClose() 
{
	#ifdef _DEBUG
	afxDump << "Closing user connection\n";
	#endif
	// deletes the player, terminates the session 

	m_lpIDC->DestroyPlayer(m_dwPlayer);
	m_lpIDC->Close();	
	CDialog::OnClose();
}


void CNetLicense::MessageSpin(void * lpvThreadParam)
{

	DWORD dwFlags;
	
	CNetLicense *MyNet = (CNetLicense *) lpvThreadParam;
	
	#ifdef _DEBUG
	afxDump << "Net Message Proc Started\n";
	#endif

	while(TRUE)
	if(WaitForSingleObject(MyNet->hPlayerEvent,INFINITE) != WAIT_TIMEOUT)
	{
		#ifdef _DEBUG
		afxDump << "Got some Message!\n";
		#endif
		if(GetHandleInformation(MyNet->hPlayerEvent,&dwFlags))
			ProcessMessage(MyNet);
		else
		{
			#ifdef _DEBUG
			afxDump << "hPlayerEvent Handle is invalid, terminating thread\n";
			#endif
			_endthread();
		}

	}

// This should run forever or until somone terminates the application
}


void CNetLicense::ProcessMessage(CNetLicense *MyNet)
{
	DPID dpIncoming;
	DPID dpOutgoing;
	struct TrapPacket
	{
		DWORD dwType;
		char szBigBuffer[1024];
	} tp; // something to cast an incoming message to.

	DWORD dwLength = sizeof(TrapPacket);

	switch(MyNet->m_lpIDC->Receive(&dpIncoming, &dpOutgoing, 
			DPRECEIVE_ALL,(char *) &tp,&dwLength))
	{
	case DP_OK:
		#ifdef _DEBUG
		afxDump << "Received and processed a message!\n"  << "\n";
		#endif

		switch(tp.dwType)
			{
			case DPSYS_DELETEPLAYER:
				DPMSG_DELETEPLAYER *sDeletePlayer =(DPMSG_DELETEPLAYER *) &tp;
				if(MyNet->m_lpIDC->DestroyPlayer(sDeletePlayer->dpId) != DP_OK)
				{
					#ifdef _DEBUG
					afxDump << "Could not delete user\n";
					#endif
				}
				else
				{
					#ifdef _DEBUG
					afxDump << "Deleted User!\n";
					#endif
				}
			break;
			}
		break;
		
	case DPERR_BUFFERTOOSMALL:
		#ifdef _DEBUG
		afxDump << "DPERR_BUFFERTOOSMALL: " << dwLength << "\n";
		#endif
		break;

	case  DPERR_NOMESSAGES:
		break;
	case  DPERR_INVALIDPARAMS:
		#ifdef _DEBUG
		afxDump << "DPERR_BUFFERTOOSMALL: " << dwLength << "\n";
		#endif
		break;
	}
}



